## Vector
1. Upewnij się, że projekt się kompiluje i uruchamia
2. Przetestuj działanie obu konstruktorów klasy Vector
3. Dodaj implementację funkcji `sum` (TODO 3), która ma stworzyć nowy wektor, który zawiera sumę element-wise. Czy da się to zrobić bez modyfikacji interfejsu Additive?
4. *Jeśli trzeba, zmodyfikuj odpowiednio interfejs Additive
5. Dodaj implementację metody `add` w MyInteger (TODO 5)
6. Czemu w ogóle potrzebujemy klasy MyInteger, skoro mamy już klasę Integer? Ciekawostka: w Scali da się rozszerzyć funkcjonalności już istniejących klas za pomocą Trait i TypeClass
7. O co chodzi z metodą statyczną `setValueInGivenVector` w klasie `Vector`? Uzupełnij jej implementację (TODO 7)

## Pair
1. Dodaj klasę `PairOfSameType` zawierającą dwa elementy tego samego typu
2. Dlaczego w bibliotece standardowej Javy nie ma klasy `Pair`?
3. Jak działa metoda `equals`?

## Optional
1. Skąd wziął się pomysł na `Optional`? Czemu nie używać nulli? Przeczytaj dokumentację klasy `Optional`
2. Przeczytaj test `optionalTest`. Czy rozumiesz cały kod?

## SOLID
1. Przeczytaj poniższe zasady (reszta na https://en.wikipedia.org/wiki/SOLID):
   * The Single-responsibility principle: "There should never be more than one reason for a class to change." In other words, every class should have only one responsibility.
   * The Open–closed principle: "Software entities ... should be open for extension, but closed for modification."
   * The Liskov substitution principle: "Functions that use pointers or references to base classes must be able to use objects of derived classes without knowing it." See also design by contract.

## Variance
1. Wariancja typów jest silnie powiązana z zasadą podstawienia Liskov. Na wariancję typów składają się dwa pojęcia: kowariancja i kontrawariancja.
   1. Kowariancja: jeśli `B` dziedziczy po `A`, to wszędzie tam, gdzie możemy wstawić obiekt klasy `A`, można wstawić obiekt klasy `B`
   2. Kontrawariancja: jeśli `B` dziedziczy po `A`, to wszędzie tam, gdzie możemy otrzymać obiekt klasy `A`, możemy otrzymać obiekt klasy `B`
2. Czy jeśli jakaś metoda spodziewa się klasy `VarianceVector<Animal>`, to możemy jej przekazać `VarianceVector<Cat>`?
3. A co jeśli jakaś metoda ma nam zwrócić `VarianceVector<Animal>`? Czy może nam zwrócić `VarianceVector<Cat>`?
4. Czy `VarianceVector<Cat>` dziedziczy po `VarianceVector<Animal>`? A może na odwrót?
5. Dodaj klasy `Cat` i `Dog` dziedziczące po `Animal` (która niejawnie dziedziczy po `Object`). Przetestuj działanie wariancji i kowariancji typów na przykładzie `VarianceVector`.
6. Spróbuj przetestować konstrukcję `VarianceVector<? extends Animal>` i `VarianceVector<? super Animal>` na przykładzie `VarianceVector`. Czy rozumiesz, co się dzieje?
