package pl.edu.uw.optional;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

public class MapStorage<Key, Value> implements Storage<Key, Value> {

    private final Map<Key, Value> data = new HashMap<>();

    public void put(Key key, Value value) {
        data.put(key, value);
    }

    public Optional<Value> get(Key key) {
        return Optional.ofNullable(data.get(key));
    }
}
