package pl.edu.uw.vector;

import java.lang.reflect.Array;

public class Vector<T extends Additive<T>> {

    private final T[] data;

    private Class<T> clazz;

    // Podejście pierwsze, tworzymy tablicę Object i rzutujemy na T
//    public Vector(int length) {
//        data = (T[]) new Object[length];
//    }

    // Podejście drugie, jako argument przyjmujemy klasę (nie instancję!) T i tworzymy tablicę T statycznym konstuktorem
    public Vector(Class<T> clazz, int length) {
        this.clazz = clazz;
        data = (T[]) Array.newInstance(clazz, length);
    }

    public T getValue(int index) {
        return data[index];
    }

    public void setValue(int index, T value) {
        data[index] = value;
    }

    public Vector<T> sum(Vector<T> other) {
        // TODO 3
        var newVector = new Vector<>(clazz, data.length);
        for (int i = 0; i < data.length; i++)
            newVector.data[i] = data[i].add(other.data[i]);
        return newVector;
    }

    public static <X extends Additive<X>> void setValueInGivenVector(Vector<? super X> vector, int index, X value) {
        // TODO 7
        vector.setValue(index, value);
    }
}
